FUNCTION IDL_TYPE, var
;+
;NAME:
;	IDL_TYPE
;
;PURPOSE:
;	return the IDL variable type
;
;CATEGORY:
;	general?
;
;CALLING SEQUENCE:
;       type = IDL_TYPE( var )
;
;INPUTS:
;	VAR	= any IDL variable
;
;OUTPUTS:
;	the type of var
;	0	Undefined
;	1	Byte
;	2	Integer
;	3	Longword integer
;	4	Floating-point
;	5	Double-precision floating
;	6	Complex floating
;	7	String
;	8	Structure
;
;COMMON BLOCKS:
;	none   
;
;SIDE EFFECTS:
;	none
;
;RESTRICTIONS:
;	none
;PROCEDURE
;	Uses IDL intrinsic function SIZE
;
;MODIFICATION HISTORY:
;	Written, Michael Andersen, October 1993
;-

  s = SIZE( var )
  RETURN, s( s(0) + 1 )

END
