
path = '/work/noise/'
suffix = '.fits'

img = readfits(path + 'bias1' + suffix, /SILENT)

border = 50
yloborder = 2048

sx = (size(img))(1)
sy = (size(img))(2)

ybeg = yloborder
nlines = sy - border - ybeg

xbeg = border
nx = 2048

avgpow = fltarr(nx)

for i=0, nlines-1 do begin
 line = img(xbeg:xbeg+nx-1, i + ybeg)
 line=line-mean(line)

; For testing
; idx=findgen(nx)
; period = 200.
; idx=idx*2.*!pi/period
; line=cos(idx)

 ftline = fft(line, -1)
 linepow = abs(ftline)^2
 avgpow = avgpow + linepow
endfor

foldpow = avgpow(0:nx/2-1) + reverse(avgpow(nx/2:nx-1))

tmp_per=findgen(nx/2)
peridx = nx / tmp_per(1:nx/2-2)
plotpow = foldpow(1:nx/2-2)

plot_oo, peridx, plotpow, $
xr=[2,100], $
ytitle="Power", xtitle="Period [pixels]"

end

