;goto, isread

path = '/work/noise/'
suffix = '.fits'

;b1 = readfits(path + 'bias1' + suffix, /SILENT)
;b2 = readfits(path + 'bias2' + suffix, /SILENT)
;f1 = readfits(path + 'flat1' + suffix, /SILENT)
;f2 = readfits(path + 'flat2' + suffix, /SILENT)

b1 = readfits(path + 'bias1' + suffix)
b2 = readfits(path + 'bias2' + suffix)
f1 = readfits(path + 'flat1' + suffix)
f2 = readfits(path + 'flat2' + suffix)

b1=ulong(b1)
b1=b1*1.0
b2=ulong(b2)
b2=b2*1.0
f1=ulong(f1)
f1=f1*1.0
f2=ulong(f2)
f2=f2*1.0

isread:

border = 0
yloborder = 0
win = 100

sx = (size(f1))(1)
sy = (size(f1))(2)

nwx = fix((sx-2*border)/win)
nwy = fix((sy-yloborder-border)/win)
ntiles=nwx*nwy

gainarr=fltarr(ntiles)
ronarr=fltarr(ntiles)
levarr=fltarr(ntiles)

for i=0,nwx-1 do begin
 for j=0,nwy-1 do begin
    sf1=f1(border+i*win: border+(i+1)*win-1, yloborder+j*win: yloborder+(j+1)*win-1)
    sf2=f2(border+i*win: border+(i+1)*win-1, yloborder+j*win: yloborder+(j+1)*win-1)
    sb1=b1(border+i*win: border+(i+1)*win-1, yloborder+j*win: yloborder+(j+1)*win-1)
    sb2=b2(border+i*win: border+(i+1)*win-1, yloborder+j*win: yloborder+(j+1)*win-1)

    gain=findgain(sf1,sb1,sf2,sb2,ron=ron)
    gainarr(i+j*nwx)=gain
    ronarr(i+j*nwx)=ron
    levarr(i+j*nwx)=(median(sf1-sb1)+median(sf2-sb2))/2    
 endfor
endfor

clpron = sigma_clp( ronarr, clip = 5, niterat = 3 )
clpgain = sigma_clp( gainarr, clip = 5, niterat = 3 )

print,"RON (e)             :",mean(clpron), " +/- ", stddev(clpron)
print,"Gain (e/ADU)        :",mean(clpgain), " +/- ", stddev(clpgain)
print,"Exposure level (ADU):",mean(levarr), " +/- ", stddev(levarr)

;print,mean(clpron), stddev(clpron), mean(clpgain), stddev(clpgain), mean(levarr), stddev(levarr), mean(sb1), stddev(sb1), mean(f1), stddev(f1)

;!p.multi=[0,1,2]

;plot, levarr, clpgain, psym=1, ytit="Gain [e-/ADU]", xtit="ADU"

;tvscl, sb1
;tvscl, sb2, win, 0
;tvscl, sb1-sb2, 2*win, 0

;tvscl, sf1, 0, win
;tvscl, sf2, win, win
;tvscl, sf1-sf2, 2*win, win

;!p.multi=[0,1,1]

end

